classification
Title: Drop support of Borland C compiler
Type: Stage: resolved
Components: Versions: Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: Arfrever, haypo, mark.dickinson, pitrou, python-dev, serhiy.storchaka
Priority: normal Keywords: patch

Created on 2014-10-09 22:00 by haypo, last changed 2014-10-23 23:02 by berker.peksag. This issue is now closed.

Files
File name Uploaded Description Edit
drop_borlandc_support.patch haypo, 2014-10-09 22:06 review
Messages (11)
msg228923 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2014-10-09 22:00
As a follow-up of the issue #22591, I propose to drop support of the Borland C compiler.

In 2000, it was nice to support Visual Studio and Borland C++ Builder, because they were the two most popular compilers on Windows. Borland C compiler could also be used on MS-DOS.

But Borland stopped the development of its C compiler, it looks like the last release is Borland C++ Builder, which was released in 2000 (I'm not sure). So this proprietary compiler is now 14 years old.

Python now focus on Visual Studio support. Microsoft gives us free licenses and a developer of Microsoft will probably build our binaries for Python 3.5. So Borland C++ Builder support is now almost useless.

On Windows, I would prefer to focus our effort on open source compilers like GCC or OpenWatcom(v2). See for example the issue #22579.
msg228926 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2014-10-09 22:06
And now with a patch.
msg229460 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2014-10-15 15:19
It looks like Larry Hastings supports indirectly this issue :-)
"We still have #ifdef's for Borland C--I'd be very surprised if anyone was compiling Python 3 with Borland C."
https://mail.python.org/pipermail/python-dev/2014-October/136626.html
msg229461 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2014-10-15 15:20
I don't know how reliable that Web site is, but apparently it may still be used for education:
http://borlandc.org/
msg229475 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2014-10-15 17:15
Antoine, antique Turbo Pascal 7.0 (for DOS!) [1] is widely used for education in xUSSR countries. Due to a bug [2] in the crt unit most education examples can't be ran on computers with modern processors (Pentium MMX and newer) and are ran under DosBox [3].

School teachers often are very conservative. The use of something for education doesn't means that it is used for other purposes.

[1] http://en.wikipedia.org/wiki/Turbo_Pascal
[2] http://en.wikipedia.org/wiki/Runtime_error_200
[3] http://en.wikipedia.org/wiki/DOSBox
msg229477 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2014-10-15 17:24
As for Borland C, it was reincarnated as Borland C++ Builder [1] and then as Embarcadero C++ Builder. I doubt that anyone was compiling Python 3 with it.

[1] http://en.wikipedia.org/wiki/C%2B%2BBuilder
msg229487 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2014-10-15 17:59
Then +1 from me for removing support.
msg229489 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2014-10-15 18:19
The patch LGTM but there is Borland C support in distutils and there are several mentions in the documentation. May be there are mentions in some build-support files.
msg229808 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2014-10-22 10:26
> The patch LGTM but there is Borland C support in distutils

As discussed on python-dev, it's fine to support more C compiler to compile extensions, than compilers supported to build Python itself.

> there are several mentions in the documentation

I did a quick check. It looks like "Borland" is usally mentionned to compile extensions, not to compile Python.

> May be there are mentions in some build-support files.

Which files?
msg229809 - (view) Author: Roundup Robot (python-dev) Date: 2014-10-22 10:33
New changeset f2ce9603346c by Victor Stinner in branch 'default':
Issue #22592: Drop support of the Borland C compiler to build Python
https://hg.python.org/cpython/rev/f2ce9603346c
msg229810 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2014-10-22 10:35
Ok, I pushed my patch. If you see remaining parts of the Borland C compiler, you can remove them in a different changeset (reopen maybe the issue?).

For distutils, I consider that it's a different topic. If you want to drop support of this compiler in distutils, please open a new issue.
History
Date User Action Args
2014-10-23 23:02:30berker.peksagsetstage: patch review -> resolved
2014-10-22 10:35:02hayposetstatus: open -> closed
resolution: fixed
messages: + msg229810
2014-10-22 10:33:45python-devsetnosy: + python-dev
messages: + msg229809
2014-10-22 10:26:33hayposetmessages: + msg229808
2014-10-15 18:19:10serhiy.storchakasetmessages: + msg229489
2014-10-15 17:59:35pitrousetmessages: + msg229487
stage: patch review
2014-10-15 17:24:11serhiy.storchakasetmessages: + msg229477
2014-10-15 17:15:39serhiy.storchakasetnosy: + serhiy.storchaka
messages: + msg229475
2014-10-15 15:20:56pitrousetnosy: + mark.dickinson, pitrou
messages: + msg229461
2014-10-15 15:19:34hayposetmessages: + msg229460
2014-10-09 22:06:41Arfreversetnosy: + Arfrever
2014-10-09 22:06:24hayposetfiles: + drop_borlandc_support.patch
keywords: + patch
messages: + msg228926
2014-10-09 22:00:53haypocreate